#!/usr/bin/python
#coding:UTF-8

import os, sys
import shutil
import time
import codecs
import re
import ConfigParser
from mig_python_logger import logger

separator = r'(?<!\\),'
#map to store user add appcrl policy
policy_appCrl = {}
#map to store user add inspection policy
policy_inspection = {}
#map to store user add urlFilter policy
policy_urlFilter = {}

priority_appCrl = []
priority_inspection = []
priority_urlFilter = []

policy_list = []

free_policy_id = []
free_policy_list_id = []

#map original policy id : new policy id
policyId_map = {}

#store all policyId for guest user
guest_policyId = []
default_policyId = []

urlFilter_max_priority = -1
appCrl_max_priority = -1
inspection_max_priority = -1

entity_id_for_default_policy = -1


default_policy_appCrl = -1
default_policy_urlFilter = -1
default_policy_inspection = -1

prefix = 'Leisure Time '

time_periodId_map = {'work_period':'1','leisure_period':'2','all_period':'3'}

def open_file(file_name, flag):

    if not os.path.exists(file_name):
        logger.error("file not exit: " + file_name)
        return None
    real_encoding = None
    encodings = ('utf-16', 'utf-8', 'gb2312')
    for encoding in encodings:
        fd = codecs.open(file_name, flag, encoding)
        try:
            fd.readline()
        except UnicodeError:
            fd.close()
        else:
            real_encoding = encoding
            fd.close()
            break
    if not real_encoding:
        logger.error("what's the file encoding? i cannot figure out")
        return None
    fd = codecs.open(file_name, flag, real_encoding)
    return fd, real_encoding

def get_guest_policyId(src_file):
    fd,coding = open_file(src_file, "r")
    line = fd.readline()
    while line:
        elements =  re.split(separator, line)
        if elements[0] == '1':
            guest_policyId.append(elements[1])
        line = fd.readline()


def handle_policy_file(src_file):

    logger.debug("in [handle_policy_file] handle rule file: " + src_file)


    global default_policy_appCrl
    global default_policy_urlFilter
    global default_policy_inspection

    # get all policy id
    policy_id = []    
    dst_file = src_file + '_temp'
    policy_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    
    line = policy_fd.readline()

#record how many policy exist
    
    while line:

#add local field in every policy
        line = line[0:-1] + ',local\n' 
        new_fd.write(line)
        elements = re.split(separator, line)
        policy_id.append(elements[0])

#produce default_policyId list
        if elements[4] == '1':
            default_policyId.append(elements[0])

            if elements[2] == '8':
                default_policy_appCrl = int(elements[0])
            elif elements[2] == '9':
                default_policy_inspection = int(elements[0])
            elif elements[2] == '1':
                default_policy_urlFilter = int(elements[0])
#change default policy to normal
            elements[4] = '0'

        if elements[2] == '8' and not (elements[0] in guest_policyId):       
            policy_appCrl[elements[0]]=elements
        elif elements[2] == '9' and not (elements[0] in guest_policyId):
            policy_inspection[elements[0]]=elements
        elif elements[2] == '1' and not (elements[0] in guest_policyId):
            policy_urlFilter[elements[0]]=elements
        else:
            pass
        line = policy_fd.readline()


    total = len(policy_appCrl)+len(policy_inspection)+len(policy_urlFilter)
    for num in range(1, len(policy_id) + total + 20):
#        if str(num) in policy_appCrl or str(num) in policy_inspection or str(num) in policy_urlFilter or str(num) in default_policyId or str(num) in guest_policyId:
        if str(num) in policy_id:
            pass
        else:
            free_policy_id.append(str(num))


#produce policyId_map    
    if len(policy_appCrl) > 0:
         for policyId,policy in policy_appCrl.items():
             policyId_map[policyId] = free_policy_id[0]
             policy[0]=free_policy_id[0]
             policy[1]=prefix+policy[1]
             new_fd.write(','.join( policy ))

             del free_policy_id[0]

    if len(policy_inspection) > 0:
         for policyId,policy in policy_inspection.items():
             policyId_map[policyId] = free_policy_id[0]
             policy[0]=free_policy_id[0]
             policy[1]=prefix+policy[1]
             new_fd.write(','.join( policy ))

             del free_policy_id[0]

    if len(policy_urlFilter) > 0:
         for policyId,policy in policy_urlFilter.items():
             policyId_map[policyId] = free_policy_id[0]
             policy[0]=free_policy_id[0]
             policy[1]=prefix+policy[1]
             new_fd.write(','.join( policy ))

             del free_policy_id[0]  
    print policyId_map         
    logger.debug("in [handle_policy_file] policyId_map: ", policyId_map)

    new_fd.close()
    
    logger.debug("In [handle_policy_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)


def handle_priority_list_file(src_file):

    logger.debug("in [handle_priority_list_file] handle file: " + src_file)
    
    global urlFilter_max_priority
    global appCrl_max_priority
    global inspection_max_priority
    
    priority_list = []
    

    dst_file = src_file + '_temp'

    priority_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = priority_fd.readline()
    while line:
     
        elements = re.split(separator,line)
#copy list elements to myElements
#we will allocate different memory space
        myElements = elements[:]
        priority_list.append(myElements)

        if elements[1] in policy_urlFilter and not (elements[1] in guest_policyId):
            if int(elements[2][0:-1]) > urlFilter_max_priority:
                urlFilter_max_priority = int(elements[2][0:-1])
        elif elements[1] in policy_appCrl and not (elements[1] in guest_policyId):
            if int(elements[2][0:-1]) > appCrl_max_priority:
                appCrl_max_priority = int(elements[2][0:-1])
        elif elements[1] in policy_inspection and not (elements[1] in guest_policyId):
            if int(elements[2][0:-1]) > inspection_max_priority:
                inspection_max_priority = int(elements[2][0:-1])


        if elements[1] in policy_urlFilter:
            priority_urlFilter.append( elements )
        elif elements[1] in policy_appCrl:
            priority_appCrl.append( elements )
        elif elements[1] in policy_inspection:
            priority_inspection.append( elements )

        
        line = priority_fd.readline()

    for element in priority_list:
        if element[1] in policy_urlFilter and not (element[1] in guest_policyId):
            element[2] = str( urlFilter_max_priority + 3 + int(element[2][0:-1]) )+'\n'
        if element[1] in policy_appCrl and not (element[1] in guest_policyId):
            element[2] = str( appCrl_max_priority + 3 + int(element[2][0:-1]) )+'\n'
        if element[1] in policy_inspection and not (element[1] in guest_policyId):
            element[2] = str( inspection_max_priority + 3 + int(element[2][0:-1]) )+'\n'
        new_fd.write(','.join(element))
    
    if len(priority_urlFilter) > 0:
        for element in priority_urlFilter:
            if element[1] in default_policyId:
                element[0] = entity_id_for_default_policy
                element[1] = policyId_map[element[1]]
                element[2] = str( urlFilter_max_priority  + 2 )+'\n' 
            elif element[1] in guest_policyId:
                element[0] = '1'
                element[1] = policyId_map[element[1]]
                element[2] = str( urlFilter_max_priority  + 1 )+'\n' 
            else:
                element[1] = policyId_map[element[1]]
            new_fd.write(','.join(element))
    if len(priority_appCrl) > 0:
        for element in priority_appCrl:
            if element[1] in default_policyId:
                element[0] = entity_id_for_default_policy
                element[1] = policyId_map[element[1]]
                element[2] = str( appCrl_max_priority + 2 )+'\n'                              
            elif element[1] in guest_policyId:
                element[0] = '1'
                element[1] = policyId_map[element[1]]
                element[2] = str( appCrl_max_priority  + 1 )+'\n'
            else:   
                element[1] = policyId_map[element[1]]
            new_fd.write(','.join(element))
    if len(priority_inspection) > 0:
        for element in priority_inspection:
            if element[1] in default_policyId:
                element[0] = entity_id_for_default_policy
                element[1] = policyId_map[element[1]]
                element[2] = str( inspection_max_priority + 2 )+'\n'                              
            elif element[1] in guest_policyId:
                element[0] = '1'
                element[1] = policyId_map[element[1]]
                element[2] = str( inspection_max_priority  + 1 )+'\n'
            else:
                element[1] = policyId_map[element[1]]
            new_fd.write(','.join(element))
    if default_policy_appCrl >0:
        new_fd.write(str(entity_id_for_default_policy) + ',' + policyId_map[str(default_policy_appCrl)] + ',' + str( appCrl_max_priority  + 2 )+'\n')
    if default_policy_urlFilter >0:
        new_fd.write(str(entity_id_for_default_policy) + ',' + policyId_map[str(default_policy_urlFilter)] + ',' + str( urlFilter_max_priority  + 2 )+'\n')
    if default_policy_inspection >0:
        new_fd.write(str(entity_id_for_default_policy) + ',' + policyId_map[str(default_policy_inspection)] + ',' + str( inspection_max_priority  + 2 )+'\n')
       
    new_fd.close()
    
    logger.debug("In [handle_priority_list_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)

def handle_policy_list_file(src_file):

    logger.debug("in [handle_policy_list_file] handle file: " + src_file)
    
    used_policy_list_id = []
    dst_file = src_file + '_temp'
    src_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = src_fd.readline()
    while line:
        new_fd.write(line)
        elements = re.split(separator,line)   
        used_policy_list_id.append(elements[0])
        if len( policyId_map ) > 0:
            if elements[1] in policyId_map:
                policy_list.append(elements)
                
        line = src_fd.readline()
    
    for num in range(1,len(used_policy_list_id)*2):
         if str(num) in used_policy_list_id:
             pass
         else:
             free_policy_list_id.append(str(num))
    
    for element in policy_list:
        element[0] = free_policy_list_id[0]
        element[1] = policyId_map[element[1]]
        del free_policy_list_id[0] 
        new_fd.write(','.join(element))

    new_fd.close()
    
    logger.debug("In [handle_policy_list_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)

def add_time_period(src_file):

    logger.debug("in [add_time_period] handle file: " + src_file)
    
    daylist=['Sunday=','Monday=','Tuesday=','Wednesday=','Thursday=','Friday=','Saturday=']

    config_reader = ConfigParser.ConfigParser()
    config_reader.read(src_file)

    workDay = config_reader.get('Policy','WorkTime_Day')
    workDay_list = list(workDay)

    am_start = config_reader.get('Policy','WorkTime_AM_Start')
    am_end = config_reader.get('Policy','WorkTime_AM_End')
    pm_start = config_reader.get('Policy','WorkTime_PM_Start')
    pm_end = config_reader.get('Policy','WorkTime_PM_End')

    am_start_min = int(am_start[0:2])*60 + int(am_start[2:4]) 
    am_end_min = int(am_end[0:2])*60 + int(am_end[2:4]) 
    pm_start_min = int(pm_start[0:2])*60 + int(pm_start[2:4]) 
    pm_end_min = int(pm_end[0:2])*60 + int(pm_end[2:4]) 


    am_start_min = am_start_min / 30 * 30
    am_end_min = am_end_min / 30 * 30
    pm_start_min = pm_start_min / 30 * 30
    pm_end_min = pm_end_min / 30 * 30
             
    work_interval = str(am_start_min) + ':' +str(am_end_min) + '|' + str(pm_start_min) + ':' + str(pm_end_min) 
    leisure_interval = str(0) + ':' + str(am_start_min) + '|' + str(am_end_min) + ':' + str(pm_start_min) + '|' + str(pm_end_min) + ':' + str(1440)

    work_period=''
    leisure_period=''
#    all_period=''

    for num in range(0,7):
        if workDay_list[num] == '1':
            work_period = work_period + daylist[num] + work_interval + ';'
            leisure_period = leisure_period + daylist[num] + leisure_interval + ';'
        else:
            leisure_period = leisure_period + daylist[num] + '0:1440;' 
#    for num in range(0,7):
#        if num < 6:
#            all_period = all_period + daylist[num] + '0:1440;'
#        else:
#           all_period = all_period + daylist[num] + '0:1440' 
 
    work_period = work_period[0:-1]
    leisure_period =  leisure_period[0:-1] 

    
    
    src_dirname = os.path.dirname(src_file)      
    src_policy_file = os.path.join(src_dirname, "tb_policy.csv")
    dst_file = os.path.join(src_dirname, "tb_time_period.csv")
    
    work_period = time_periodId_map['work_period']+',working time,' + work_period + ',working time,local\n'
    leisure_period = time_periodId_map['leisure_period'] + ',leisure time,' + leisure_period + ',leisure time,local\n'
#    all_period = time_periodId_map['all_period'] + ',always,' + all_period + ',always,local\n'
    
 
    src_fd,coding = open_file(src_policy_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
  # line = src_fd.readline()
  # while line:
  #     print line
  #     elements = re.split(separator,line)
  #     print elements
  #     line = src_fd.readline()
    new_fd.write(work_period)
    new_fd.write(leisure_period)
#    new_fd.write(all_period)
    new_fd.close()

def convert_appCrl_rule(ruleValue):
    category = ruleValue.split('|')[0].split('=')
    category_list = list(category[1])
    result = category[0] + '='
    for num in range(0,len(category_list)):
        if category_list[num] == '1':
            result = result + str(num)+':1:0;'
    return result
       

def handle_rule_file(src_file):

    logger.debug("in [handle_rule_file] handle file: " + src_file)

    dst_file = src_file + '_temp'
    src_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = src_fd.readline()
    while line:
        line = line.replace('max_synchronous_scan_size=10240','max_synchronous_scan_size=65536')
        elements = re.split(separator,line)
        
        #for appCrl rule, we need convert
        if elements[1] in policy_appCrl:
            elements[3] = convert_appCrl_rule(elements[3][0:-1])+'\n'
            
        if elements[2] == '1':
            elements[2] = '247'
            elements.insert(2,'-1')
        elif elements[2] == '0':
            if elements[1] in policyId_map:
                elements[1] = policyId_map[elements[1]]
                elements.insert(2,'2')
                elements[3] = '247'
#do not record https decripting policy which active time is 0
            else:
                elements = []
                 
        else:
            elements.insert(2,'-1')
        if len(elements) > 0:
            new_fd.write(','.join(elements))
        line = src_fd.readline()

    new_fd.close()
    logger.debug("In [handle_rule_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)

def handle_entity_file(src_file):

    logger.debug("in [handle_entity_file] handle file: " + src_file)
    global entity_id_for_default_policy

    entity_map = {}
    free_entityId = []
    dst_file = src_file + '_temp'
    src_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = src_fd.readline()
    while line:
        new_fd.write(line)
        elements = re.split(separator,line)
        entity_map[elements[0]] = elements
        line = src_fd.readline()
    for num in range(1,len(entity_map)+2):
        if str(num) in entity_map:
            pass
        else:
            free_entityId.append(str(num))
    new_entity = free_entityId[0]+',5,0.0.0.0 ~ 255.255.255.255\n'
    entity_id_for_default_policy = free_entityId[0]
    del free_entityId[0]
    new_fd.write(new_entity)
    new_fd.close()
    
    logger.debug("In [handle_entity_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)

def handle_list_file(src_file):

    logger.debug("in [handle_list_file] handle file: " + src_file)
    dst_file = src_file + '_temp'
    src_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = src_fd.readline()
    while line:
        line = line[0:-1] + ',local\n'
        new_fd.write(line)
        line = src_fd.readline()


    new_fd.close()
    logger.debug("In [handle_list_file] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)

def handle_report_template(src_file):

    logger.debug("in [handle_report_template] handle file: " + src_file)
    dst_file = src_file + '_temp'
    src_fd,coding = open_file(src_file, "r")
    new_fd = codecs.open(dst_file, "w", coding)
    line = src_fd.readline()
    while line:
        elements = re.split(separator,line)
        print len(elements)
        if len(elements) == 28:
            line = line[0:-1] + ',0\n'
            new_fd.write(line)
        else:
            new_fd.write(line)
        line = src_fd.readline()

    new_fd.close()
    logger.debug("In [handle_report_template] copy file: " + dst_file + "to file: " + src_file)
    shutil.copy2(dst_file, src_file)


if __name__ == "__main__":


    if len(sys.argv) < 3:
        print "Usage: " + sys.argv[0]+ " src_tb_rule.csv dst_tb_rule.csv"
        logger.error(sys.argv[0] + ": Missing the parameter")

    else:

        src_rule_file = sys.argv[1]
        dst_rule_file = sys.argv[2]

        src_dirname = os.path.dirname(sys.argv[1])
        dst_dirname = os.path.dirname(sys.argv[2])

        src_policy_file = os.path.join(src_dirname, "tb_policy.csv")
        src_priority_list_file = os.path.join(src_dirname, "tb_prioritylist.csv")
        src_policy_list_file = os.path.join(src_dirname, "tb_policylist.csv")
        src_list_file = os.path.join(src_dirname, "tb_list.csv")
        src_customcategoryurlentry = os.path.join(src_dirname, "tb_customcategoryurlentry.csv")
        src_entity_file = os.path.join(src_dirname, "tb_entity.csv")
        src_time_period_file = os.path.join(src_dirname, "tb_time_period.csv")
        src_report_template_file = os.path.join(src_dirname, "tb_report_template.csv")
        
        src_intscan_file = os.path.join(src_dirname, "intscan.ini")
        
        dst_policy_file = os.path.join(dst_dirname, "tb_policy.csv")
        dst_priority_list_file = os.path.join(dst_dirname, "tb_prioritylist.csv")
        dst_policy_list_file = os.path.join(dst_dirname, "tb_policylist.csv")
        dst_list_file = os.path.join(dst_dirname, "tb_list.csv")
        dst_customcategoryurlentry = os.path.join(dst_dirname, "tb_customcategoryurlentry.csv")
        dst_entity_file = os.path.join(dst_dirname, "tb_entity.csv")
        dst_time_period_file = os.path.join(dst_dirname, "tb_time_period.csv")
        dst_report_template_file = os.path.join(dst_dirname, "tb_report_template.csv")
        
        
        
        
        if not os.path.exists(src_rule_file):
            logger.error('Execute [db_table_convert] not find the file:' + src_rule_file)      
        if not os.path.exists(src_policy_file):
            logger.error('Execute [db_table_convert] not find the file:' + src_policy_file)
        if not os.path.exists(src_priority_list_file):
            logger.error('Execute [db_table_convert] not find the file:' + src_priority_list_file)
        if not os.path.exists(src_policy_list_file):
            logger.error('Execute [db_table_convert] not find the file:' + src_policy_list_file)
        if not os.path.exists(src_list_file):
            logger.error('Execute [db_table_convert] not find the file:' + src_list_file)
        if not os.path.exists(src_customcategoryurlentry):
            logger.error('Execute [db_table_convert] not find the file:' + src_customcategoryurlentry)

        logger.debug('entry into [db_table_convert_6.0_to_6.0sp1.py] ... ...')

        #backup origin files that related with policy setting
        shutil.copy2( src_rule_file, src_rule_file + ".backup")
        shutil.copy2( src_policy_file, src_policy_file + ".backup")
        shutil.copy2( src_priority_list_file, src_priority_list_file + ".backup")
        shutil.copy2( src_policy_list_file, src_policy_list_file + ".backup")
        shutil.copy2( src_list_file, src_list_file + ".backup")
        shutil.copy2( src_customcategoryurlentry, src_customcategoryurlentry + ".backup")
        
        #handle csv file
        handle_entity_file(src_entity_file)
        get_guest_policyId(src_priority_list_file)
        handle_policy_file(src_policy_file)
        handle_priority_list_file(src_priority_list_file)
        handle_policy_list_file(src_policy_list_file)
        add_time_period(src_intscan_file)
    
        handle_list_file(src_list_file)
        handle_list_file(src_customcategoryurlentry)
        handle_rule_file(src_rule_file)
        handle_report_template(src_report_template_file)
        
        #copy csv to dst 
        logger.debug("in [main] copy file: " + src_rule_file + "to file: " + dst_rule_file)
        shutil.copy2(src_rule_file, dst_rule_file)
        logger.debug("in [main] copy file: " + src_policy_file + "to file: " + dst_policy_file)
        shutil.copy2(src_policy_file, dst_policy_file)
        logger.debug("in [main] copy file: " + src_priority_list_file + "to file: " + dst_priority_list_file)
        shutil.copy2(src_priority_list_file, dst_priority_list_file)
        logger.debug("in [main] copy file: " + src_policy_list_file + "to file: " + dst_policy_list_file)
        shutil.copy2(src_policy_list_file, dst_policy_list_file)
        logger.debug("in [main] copy file: " + src_list_file + "to file: " + dst_list_file)
        shutil.copy2(src_list_file, dst_list_file)
        logger.debug("in [main] copy file: " + src_customcategoryurlentry + "to file: " + dst_customcategoryurlentry)
        shutil.copy2(src_customcategoryurlentry, dst_customcategoryurlentry)
        logger.debug("in [main] copy file: " + src_entity_file + "to file: " + dst_entity_file)
        shutil.copy2(src_entity_file, dst_entity_file)
        logger.debug("in [main] copy file: " + src_time_period_file + "to file: " + dst_time_period_file)
        shutil.copy2(src_time_period_file, dst_time_period_file)
        logger.debug("in [main] copy file: " + src_report_template_file + "to file: " + dst_report_template_file)
        shutil.copy2(src_report_template_file, dst_report_template_file)
            
        
          

        logger.debug('exit[db_table_convert_6.0_to_6.0sp1.py] ... ...')
    
