(function( $ ){

  function update_form() {
	$.ajaxSetup({
		async: false
	});
    $.get("/rest/commonlog/log_setting/purge", function(purge) {
      loader(0);
      if (purge) {
        $("#json-purge_days").val( purge.purge_days );
        $("#json-purge_size").val( purge.purge_size );
		old_pd = purge.purge_days;
		old_ps = purge.purge_size;
      }
      loader(1);
    });
  }

  function update_anonymous() {
	$.ajaxSetup({
		async: false
	});
    $.get("/rest/commonlog/log_setting/anonymous", function(value) {
      loader(0);
      if (value) {
         state=value.isEnable;
         if(state == "yes")
         {
            document.getElementById("anonymous_button").value = "Disable";
            document.getElementById("anonymous_state").innerHTML ="Enabled";
         }else{

            document.getElementById("anonymous_button").value = "Enable";
            document.getElementById("anonymous_state").innerHTML ="Disabled";
         }

      }
      loader(1);
    });
  }



  function update_filter() {
	$.ajaxSetup({
		async: false
	});
    $.get("/rest/commonlog/log_setting/filter", function(filter) {
      loader(0);
      var scope = document.getElementById("logType_0");
      scope.options[1].selected = true;
      if (filter) {
                jsIniFirstRow(filter);
                for(var i=1; i<filter.length;i++)
                {
                    jsAppendRow(filter);
                }
      }
      loader(1);
    });
  }


function jsAppendRow(filter)
{
   var RowLength = document.getElementsByName("Plus_icon").length;
   var Ptable = document.getElementById("tblDefineTemp");
   var row=Ptable.getElementsByTagName("tr");
   var rLen=row.length;
   var BlankRow=Ptable.insertRow(rLen); //seperate
   var BlankCell = BlankRow.insertCell(0);
   BlankCell.colspan = "7";
   BlankCell.style.height = "3px";
   var oRow=Ptable.insertRow(rLen+1);
   for(var t=0;t<6;t++)
   {
       var oCell=oRow.insertCell(t);
       oCell.className="Filter";
       oCell.innerHTML = row[0].cells[t].innerHTML;
   }
   oRow.cells[0].firstChild.style.visibility="visible";
   oRow.cells[0].firstChild.id = RowLength;
   oRow.cells[2].firstChild.style.visibility = "visible";
   oRow.cells[3].firstChild.id = "logType_"+RowLength;
   oRow.cells[3].firstChild.options[0].selected = true;
   i = parseInt(filter[RowLength].type);
   oRow.cells[3].firstChild.options[i].selected = true;

   scope_option = oRow.cells[4].firstChild;
   if(0 == i)
   {
        for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
        scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
   }else
   {
        for(var i=0;i<scope_option.options.length;)
	{
		scope_option.removeChild(scope_option.options[i]);
	}
        scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_user,"user"));
        scope_option.options.add(new Option(i18n.report_logsetting.OPTION.GLOBAL_LOG_SETTINGS_dom,"dom"));
   } 
 
   oRow.cells[4].firstChild.id = "scope_"+RowLength;
   if( "" == filter[RowLength].user){
       oRow.cells[4].firstChild.options[1].selected = true;
       oRow.cells[5].firstChild.value=filter[RowLength].dom;
   }
   else{
       oRow.cells[4].firstChild.options[0].selected = true;
       oRow.cells[5].firstChild.value=filter[RowLength].user;
   }
   oRow.cells[5].firstChild.id="value_"+RowLength;


}



  function jsIniFirstRow(filter)
  {

   i = parseInt(filter[0].type)
   var type = document.getElementById("logType_0");
   type.options[i].selected = true;
   //remove dom options for bandwith
   if (0 == i)
   {
       var scope = document.getElementById("scope_0");
       if( 2 == scope.options.length )
       {
           scope.removeChild(scope.options[1]);
       }
   }

   if( "" == filter[0].user){
       var scope = document.getElementById("scope_0");
       scope.options[1].selected = true;
       var value = document.getElementById("value_0");
       value.value = filter[0].dom;
   }else{
       var scope = document.getElementById("scope_0");
       scope.options[0].selected = true;
       var value = document.getElementById("value_0");
       value.value = filter[0].user;
   }
  }


  function init_page() {
    update_form();
    update_filter();
    update_anonymous();

	//var old_pd = $("#json-purge_days").val();
	//var old_ps = $("#json-purge_size").val();

    $("#save_log_setting").bind("click", function(e) {
      var pd = String(parseInt( $("#json-purge_days").val() ));
      var ps = String(parseInt( $("#json-purge_size").val() ));

	  if(old_pd == pd && old_ps == ps) {
			alert(i18n.report_logsetting.MESSAGE.NO_CHANGE);
			update_form();
			return;
	}

	  if(isNaN(pd) || isNaN(ps) || pd <= 0 || ps <= 0) {
		alert( i18n.report_logsetting.MESSAGE.PURGE_SETTINGS_INPUT_INVALID );
		update_form();
		return;
	  }

      request = {"purge_days": pd,"purge_size": ps};
      loader(0);
      $.ajax({
        url: "/rest/commonlog/log_setting/purge",
        dataType: "json",
        async: false,
        type: "POST",
        data: JSON.stringify(request),
        success: function(data) {
          alert( i18n.report_logsetting.MESSAGE.SAVE_PURGE_SETTINGS_SUCCESS );
          loader(1);
        },
        error: function(a, b, c) {
		  alert( i18n.report_logsetting.MESSAGE.PURGE_SETTINGS_INPUT_INVALID_SIZE );
          loader(1);
          $("html, body").animate({ scrollTop: 0 }, "slow");
          console.log("ERROR:", a, b, c);
        }
      });
      update_form();
    }).bind("keyup", function(e) {
      if (e.keyCode == 13) {
        $(this).click();
      }
    });




    $("#save_filter_setting").bind("click", function(e) {

		var array = [];
		var RowLength = document.getElementsByName("Plus_icon").length;
		for(var i=0; i < RowLength; i++) {
			var logType=document.getElementById("logType_"+i).value;
			var scope=document.getElementById("scope_"+i).value;
			var value=document.getElementById("value_"+i).value;
			String.prototype.Trim = function() {
				return this.replace(/(^\s*)|(\s*$)|(\n)/g, "");
			}
			value = value.Trim();
			if("" == value) {
				alert( i18n.report_logsetting.MESSAGE.VALUE_NOT_EMPTY );
				document.getElementById("value_"+i).focus();
				return;
			}

			if(scope == "dom") {
				user="";
				dom=value;
			} else {
				dom="";
				user=value
			}
			request = {"type": logType,"user": user,"dom": dom};
			array.push(request);
		}

		loader(0);
		$.ajax({
			url: "/rest/commonlog/log_setting/filter",
			dataType: "json",
			async: false,
			type: "POST",
			data: JSON.stringify(array),
			success: function(data) {
				alert( i18n.report_logsetting.MESSAGE.SAVE_FILTER_SETTINGS_SUCCESS );
				loader(1);
			},
			error: function(a, b, c) {
				loader(1);
				$("html, body").animate({ scrollTop: 0 }, "slow");
				console.log("ERROR:", a, b, c);
			}
		});
    }).bind("keyup", function(e) {
		if (e.keyCode == 13) {
			$(this).click();
		}
    });




   $("#clear_filter_setting").bind("click", function(e) {
	if($('#clear_flag').val() == "clear") {
      loader(0);
      $.ajax({
        url: "/rest/commonlog/log_setting/filter_clear",
        dataType: "json",
        async: false,
        type: "POST",
        data: "",
        success: function(data) {
          alert( i18n.report_logsetting.MESSAGE.CLEAR_FILTER_SETTINGS_SUCCESS );
          loader(1);
		  $('#clear_flag').val("");
        },
        error: function(a, b, c) {
          loader(1);
          $("html, body").animate({ scrollTop: 0 }, "slow");
          console.log("ERROR:", a, b, c);
		  $('#clear_flag').val("");
        }
      });
	}
    }).bind("keyup", function(e) {
      if (e.keyCode == 13) {
        $(this).click();
      }
    });


    $("#anonymous_button").bind("click", function(e) {

      op= document.getElementById("anonymous_button").value;
      if(op == "Enable")
      {
          request = {"isEnable":"yes"};
      }else{

          request = {"isEnable":"no"};
      }
      loader(0);
      $.ajax({
        url: "/rest/commonlog/log_setting/anonymous",
        dataType: "json",
        async: false,
        type: "POST",
        data: JSON.stringify(request),
        success: function(data) {
          alert( i18n.report_logsetting.MESSAGE.ANONYMOUS_SUCESS );
          if(op == "Enable")
          {
            document.getElementById("anonymous_button").value = "Disable";
            document.getElementById("anonymous_state").innerHTML ="Enabled";
          }else{
            document.getElementById("anonymous_button").value = "Enable";
            document.getElementById("anonymous_state").innerHTML ="Disabled";
          }

          loader(1);
        },
        error: function(a, b, c) {
          loader(1);
          $("html, body").animate({ scrollTop: 0 }, "slow");
          console.log("ERROR:", a, b, c);
        }
      });
    }).bind("keyup", function(e) {
      if (e.keyCode == 13) {
        $(this).click();
      }
    });



  }
  init_page();
  var old_pd = $("#json-purge_days").val();
  var old_ps = $("#json-purge_size").val();

})( jQuery );
