#!/usr/bin/env python
# -*- coding: utf-8 -*-

import time
import sys
import os
import logging
sys.path += [os.path.join(os.path.dirname(__file__), 'config')]
sys.path += [os.path.join(os.path.dirname(__file__), 'handlers')]
sys.path += [os.path.join(os.path.dirname(__file__), 'common')]
from report_task import getTasks
from report_task import executeTask
from report_config import ReportConfig

class scheduler():

    def getTasks(self):
        logging.info('scheduler.getTasks: currentTime = %d', time.time())
        self.tasks = getTasks()
        logging.info('scheduler.getTasks: get %d tasks', len(self.tasks))

    def executeTasks(self):
        logging.info('scheduler.executeTasks')
        if self.tasks:
            for task in self.tasks:
                try:
                    executeTask(task)
                except Exception, e:
                    logging.info('exception when execteTask: %e', e)
        logging.info('scheduler.executeTasks: finish executing tasks')

def main():
    ReportConfig.init()
    logging.info('############## scheduler for report start up ##############')
    if ReportConfig.SERVER_ROLE == 2:
        logging.info('The IWSVA server is log source. Quit report scheduler.')
        sys.exit(0)

    sch = scheduler()
    sch.getTasks()
    sch.executeTasks()

    logging.info('##############   scheduler for report end    ##############')

if __name__ == '__main__':
    main()
