#!/bin/sh

# global var:
#  APP_PATCH_ROOT=/etc/iscan
#  PATCHINFOINI=stargate_patch.ini
#  PATCHMGMINI=${INSTALL_DIR}/patch/config/patch_management.ini
#  PATCH_NUMBER=`F_ini_get $PATCHINFOINI PatchInfo Number`

# will be called before database is shutdown.
F_apply_database_changes()
{
    echo F_apply_database_changes
}

# will be called before database is shutdown.
F_rollback_database_changes()
{
    echo F_rollback_database_changes
}

F_binary_extra_copy()
{
    echo "Updating ldap lib"
    cp -f files/libprotobuf-lite.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/
    cp -f files/libprotobuf.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/
    cp -f files/libprotoc.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/
    cp -f files/libprotobuf-lite.so.8.0.0 /usr/iwss/lib/
    cp -f files/libprotobuf.so.8.0.0 /usr/iwss/lib/
    cp -f files/libprotoc.so.8.0.0 /usr/iwss/lib/
    chown iscan:iscan /var/iwss/commonldap/libprotobuf/lib/libpro*
    chmod 755 /var/iwss/commonldap/libprotobuf/lib/libpro*
    chown iscan:iscan /usr/iwss/lib/libpro*
    chmod 755 /usr/iwss/lib/libpro*
	
	rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so
	ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.8
    ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so

	rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so
	ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.8
    ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so	
	
	rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotoc.so
	ln -s /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.8.0.0 /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.8
    ln -s /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotoc.so	
	
	rm -rf /usr/iwss/lib/libprotobuf-lite.so
	ln -s /usr/iwss/lib/libprotobuf-lite.so.8.0.0 /usr/iwss/lib/libprotobuf-lite.so.8
    ln -s /usr/iwss/lib/libprotobuf-lite.so.8 /usr/iwss/lib/libprotobuf-lite.so
	
	rm -rf /usr/iwss/lib/libprotobuf.so
	ln -s /usr/iwss/lib/libprotobuf.so.8.0.0 /usr/iwss/lib/libprotobuf.so.8
    ln -s /usr/iwss/lib/libprotobuf.so.8 /usr/iwss/lib/libprotobuf.so	
	
	rm -rf /usr/iwss/lib/libprotoc.so
	ln -s /usr/iwss/lib/libprotoc.so.8.0.0 /usr/iwss/lib/libprotoc.so.8
    ln -s /usr/iwss/lib/libprotoc.so.8 /usr/iwss/lib/libprotoc.so

    chown --no-dereference iscan:iscan /var/iwss/commonldap/libprotobuf/lib/libpro*
    chmod 755 /var/iwss/commonldap/libprotobuf/lib/libpro*
    chown --no-dereference iscan:iscan /usr/iwss/lib/libpro*
    chmod 755 /usr/iwss/lib/libpro*

    echo "Sync LDAP"
    /etc/iscan/commonldap/LdapSyncTool.sh > /dev/null 2>&1
    
    
    #hfb1236: remove ixEngine files; use the *.so only, for example, libtmctl.so.
    rm -f /usr/iwss/lib/libtmctl.so.2.5.1013
    rm -f /usr/iwss/lib/libtmdata.so.2.5.1013
    rm -f /usr/iwss/lib/libtmengine.so.2.5.1013
    rm -f /usr/iwss/lib/libtmfilter.so.2.5.1013
    rm -f /usr/iwss/lib/libtmprotocols.so.2.0.3145
    rm -f /usr/iwss/lib/libtmprotodef.so.2.0.3145
    rm -f /usr/iwss/lib/libtmsecurity.so.2.5.1013
	
}

F_update_extra_ini() {
	echo "Updating the ini file."

    IWSS_DATA=/var/iwss
    INTSCAN_CONF=$IWSS_DATA/intscan.ini
    URLF_CONF=$IWSS_DATA/urlfcIFX.ini
    HTTP_CONF=$IWSS_DATA/IWSSPIProtocolHttpProxy.pni

    #change the tmsyslog conf, /var/log/messages will not cleaned when tmsyslog is restarted
    sed '/libtmlog_om_file/'d /etc/tmsyslog.conf > /etc/tmsyslog_tmp.conf
    cp -f /etc/tmsyslog_tmp.conf /etc/tmsyslog.conf
    rm -f /etc/tmsyslog_tmp.conf

    #TT296052 Set total_partition into /var/iwss/iwssCache.ini file when it is empty
    /usr/iwss/AdminUI/cache_helper.sh GetCacheInfo > /dev/null 2>&1
    #TT300064: Change CCR schedule time to avoid conflict with pattern update.
    sed -i "s/<cron-expression>0 0 \* \* \* ?<\/cron-expression>/<cron-expression>0 20 \* \* \* ?<\/cron-expression>/g" \
    /etc/iscan/AdminUI/tomcat/webapps/ROOT/WEB-INF/classes/quartz_job.xml
    #hfb1236: change kernel parameters for performance purpose
    sed -i "s/^net.ipv4.tcp_rmem=4096 262144 262144/net.ipv4.tcp_rmem=4096 262144 4194304/g" /etc/sysctl.conf
    sed -i "s/^net.ipv4.tcp_wmem=4096 262144 262144/net.ipv4.tcp_wmem=4096 262144 4194304/g" /etc/sysctl.conf
    sed -i "s/^net.ipv4.tcp_window_scaling=0/net.ipv4.tcp_window_scaling=1/g" /etc/sysctl.conf
    sed -i "s/^net.netfilter.nf_conntrack_max=1048576/net.netfilter.nf_conntrack_max=2097152/g" /etc/sysctl.conf
    sed -i "s/^net.nf_conntrack_max=1048576/net.nf_conntrack_max=2097152/g" /etc/sysctl.conf
    sed -i "s/^net.core.rmem_default=262141/net.core.rmem_default=4194304/g" /etc/sysctl.conf
    sed -i "s/^net.core.wmem_default=262141/net.core.wmem_default=4194304/g" /etc/sysctl.conf
    sed -i "s/^fs.file-max=209708/#fs.file-max=209708/g" /etc/sysctl.conf
    sed -i "s/^net.ipv4.tcp_max_tw_buckets=360000/net.ipv4.tcp_max_tw_buckets=720000/g" /etc/sysctl.conf
    /sbin/sysctl -p > /dev/null 2>&1
}

# will be called after binary copying
F_apply_extra_changes()
{
	echo F_apply_extra_changes

	F_binary_extra_copy
	F_update_extra_ini
}

# will be called after binary copying
F_rollback_extra_changes()
{

   _applied_patches=`F_ini_get $PATCHMGMINI PatchManagement AppliedPatches`
   _applied_patch1="no"
   #stop if the patch number is already in AppliedPatches..
   for i in $_applied_patches
   do
       if [ "$i" = "Patch1_B1215" ] ; then
           _applied_patch1="yes"
       fi
   done
   echo "install patch 1 [$_applied_patch1]"
   
   
   #Michael if IWSVA 6.0 SP1 have installed patch 1, we can NOT run the script below. 
   if [ "no" = "$_applied_patch1" ]; then
       echo "Rollback ldap lib"
   	   rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.8.0.0
   	   ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so.7 /var/iwss/commonldap/libprotobuf/lib/libprotobuf-lite.so
   	   
   	   rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.8.0.0
   	   ln -s /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so.7 /var/iwss/commonldap/libprotobuf/lib/libprotobuf.so	
   	   
   	   rm -rf /var/iwss/commonldap/libprotobuf/lib/libprotoc.so /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.8 /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.8.0.0
   	   ln -s /var/iwss/commonldap/libprotobuf/lib/libprotoc.so.7 /var/iwss/commonldap/libprotobuf/lib/libprotoc.so	
   	   
   	   rm -rf /usr/iwss/lib/libprotobuf-lite.so /usr/iwss/lib/libprotobuf-lite.so.8 /usr/iwss/lib/libprotobuf-lite.so.8.0.0
   	   ln -s /usr/iwss/lib/libprotobuf-lite.so.7 /usr/iwss/lib/libprotobuf-lite.so
   	   
   	   rm -rf /usr/iwss/lib/libprotobuf.so /usr/iwss/lib/libprotobuf.so.8 /usr/iwss/lib/libprotobuf.so.8.0.0
   	   ln -s /usr/iwss/lib/libprotobuf.so.7 /usr/iwss/lib/libprotobuf.so
   	   
   	   rm -rf /usr/iwss/lib/libprotoc.so /usr/iwss/lib/libprotoc.so.8 /usr/iwss/lib/libprotoc.so.8.0.0
   	   ln -s /usr/iwss/lib/libprotoc.so.7 /usr/iwss/lib/libprotoc.so
   	
       chown --no-dereference iscan:iscan /var/iwss/commonldap/libprotobuf/lib/libpro*
       chmod 755 /var/iwss/commonldap/libprotobuf/lib/libpro*
       chown --no-dereference iscan:iscan /usr/iwss/lib/libpro*
       chmod 755 /usr/iwss/lib/libpro*
   
       echo "Sync LDAP"
       /etc/iscan/commonldap/LdapSyncTool.sh > /dev/null 2>&1
   fi 
}
